from wordcloud import WordCloud, STOPWORDS
import matplotlib.pyplot as plt
import json
from pprint import pprint
from os import walk
from matplotlib.pylab import *
import scipy.stats
from collections import Counter
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
import itertools
import math
import networkx as nx
from scipy.stats import gmean
from cycler import cycler
import datetime
import operator
import matplotlib.image as image
import pylab as pl
import numpy as np
from PIL import Image
from matplotlib._png import read_png
from matplotlib.offsetbox import TextArea, DrawingArea, OffsetImage, AnnotationBbox
from matplotlib.cbook import get_sample_data
from matplotlib._png import read_png

f = []
for (dirpath, dirnames, filenames) in walk('compos'):
    f.extend(filenames)

comp_exl = ["1_144508536966337339","1_144516580728766407","1_144517623524708722", "1_144517739746427313","1_144213724673407536", "1_144509553048589334", "1_144516467818525751","1_144517820338980663","1_144215085311068884","1_144509554914534382","1_144517004087450478","1_144518260753995694","1_144508525997707408","1_144509658317056217","1_144517595139106738","1_144518664087056338","1_144508863502906376","1_144509739173204213","1_144517649043738524","1_144527616435284914","1_144509090646850972", "1_144516088555899553"]
orig_matrix = {}

with open("res_01.csv") as forig:
    for line in forig:
    	if line[0] != "S":
    		sline = line.split(' , ')
    		if sline[0] not in orig_matrix.keys():
    			orig_matrix[sline[0]] = {}
    		orig_matrix[sline[0]][sline[2]] = float(sline[4])

for x in orig_matrix.keys():
	for y in orig_matrix[x].keys():
		if y not in orig_matrix.keys():
			orig_matrix[y]={}
		orig_matrix[y][x] = orig_matrix[x][y]

compos = {}

for fil in f:
	if fil[-3:] == '.js' and fil[0] != 'm':
		with open('compos/' + fil) as data_file:    
		    compos[fil[:-3]] = json.load(data_file)

#print len(compos.keys()), "compositions"
#for x in comp_exl:
#	if x in compos.keys():
#		print x

""" compos stats stats """
games = []
words = []
guesses = []
guessed = []
guess_ratio = []
word_ratio = []

topic_guess_ratio = {}
creats = []
guessts = []
origs = []
interlen = []
intert = []
bricks = []
numpix = []

orig_t = {}
new_orig_t = {}

users_comp = {}
users_gues = {}

origs_intert = [[],[]]
origs_interlen = [[],[]]
origs_gr = [[],[],[]]

topic_words = {}

compos_topic = {}
orig_influ = []
orig_ninflu = []

bricks = {}
topic_bricks = {}

for x in compos.keys():
	for y in compos[x]["bricks"]:
		brickey = str(y["width"])+"_"+str(y["height"])+"_"+y["color"]
		if brickey not in bricks.keys():
			bricks[brickey] = 1
		else:
			bricks[brickey] += 1

		if compos[x]["conceptid"] not in topic_bricks.keys():
			topic_bricks[compos[x]["conceptid"]] = {}
		if brickey not in topic_bricks[compos[x]["conceptid"]].keys():
			topic_bricks[compos[x]["conceptid"]][brickey] = 1
		else:
			topic_bricks[compos[x]["conceptid"]][brickey] += 1

	if compos[x]["conceptid"] not in compos_topic.keys():
		compos_topic[compos[x]["conceptid"]] = []
	compos_topic[compos[x]["conceptid"]].append(x)

	if compos[x]["userid"] not in users_comp.keys():
		users_comp[compos[x]["userid"]] = []
	users_comp[compos[x]["userid"]].append(x) 

	if "guesses" in compos[x].keys():
		for y in compos[x]["guesses"]:
			guessts.append(y["submissionts"])
			if y["userid"] not in users_gues.keys():
				users_gues[y["userid"]] = []
			users_gues[y["userid"]].append((x,int(y["submissionts"])))

	if "notguesses" in compos[x].keys():
		for y in compos[x]["notguesses"]:
			guessts.append(y["submissionts"])
			if y["userid"] not in users_gues.keys():
				users_gues[y["userid"]] = []
			users_gues[y["userid"]].append((x,int(y["submissionts"])))

time_sorted_keys = sorted( compos.keys(), key=lambda x: x[2:])

for x in time_sorted_keys:
	if compos[x]["conceptid"] not in orig_t.keys():
		orig_t[compos[x]["conceptid"]] = []
	orig_t[compos[x]["conceptid"]].append(compos[x]["originality"])

	if compos[x]["conceptid"] not in new_orig_t.keys():
		new_orig_t[compos[x]["conceptid"]] = []
	tmp_orig = []
	for z in orig_matrix[x].keys():
		if  z < x and z not in comp_exl:
			if compos[z]["conceptid"] == compos[x]["conceptid"]:
				tmp_orig.append(orig_matrix[x][z])
		if len(tmp_orig) == 0:
			tmp_orig.append(1)
	new_orig_t[compos[x]["conceptid"]].append(np.average(tmp_orig))

#	print compos[x]["originality"], orig_matrix[x]
	if compos[x]["conceptid"] not in topic_words.keys():
		topic_words[compos[x]["conceptid"]] = []

	intert.append(compos[x]["duration"])
	interlen.append(len(compos[x]["interactions"]) - 2)
	numpix.append(len(compos[x]["matrix"].keys()))
	origs.append(compos[x]["originality"])
	if len(compos[x]["interactions"]) - 2 > 0:
		origs_interlen[0].append(compos[x]["originality"])
		origs_interlen[1].append(len(compos[x]["interactions"]) - 2)
	if compos[x]["duration"] > 0:
		origs_intert[0].append(compos[x]["originality"])
		origs_intert[1].append(compos[x]["duration"])

	tentative = 0
	if "guesses" in compos[x].keys():
		g = len(compos[x]["guesses"])
#		print compos[x]["guesses"]
		for y in compos[x]["guesses"]:
			for z in y["interactions"]:
				if z["type"] not in ("start","end","fail"):
					words.append(z["type"].lower())
					topic_words[compos[x]["conceptid"]].append(z["type"].lower())
					tentative+=1
	else:
		g = 0

	if "notguesses" in compos[x].keys():
		ng = len(compos[x]["notguesses"])
		for y in compos[x]["notguesses"]:
			for z in y["interactions"]:
				if z["type"] not in ("start","end","fail"):
					words.append(z["type"].lower())
					topic_words[compos[x]["conceptid"]].append(z["type"].lower())
					tentative+=1
	else:
		ng = 0
	games.append(g + ng)
	guesses.append(tentative)
	guessed.append(g)
#	print x
	if "creationts" in compos[x].keys():
		creats_tmp = compos[x]["creationts"] 
	else:
		if "edits" in compos[x].keys():
			creats_tmp = min([y["submissionts"] for y in compos[x]["edits"]],compos[x]["submissionts"])
		else:
			creats_tmp = compos[x]["submissionts"] 

	if compos[x]["conceptid"] not in topic_guess_ratio.keys():
		topic_guess_ratio[compos[x]["conceptid"]] = [0,0]

	if creats_tmp > 1444983700 and g+ng > 0 and tentative > 0:
		guess_ratio.append(1.*g/(g + ng))
		origs_gr[0].append(compos[x]["originality"])
		origs_gr[1].append(1.*g/(g + ng))
		topic_guess_ratio[compos[x]["conceptid"]][0] += 1.*g
		topic_guess_ratio[compos[x]["conceptid"]][1] += 1.*g + 1.*ng
		tmp_orig2 = []
		for z in orig_matrix[x].keys():
			if z < x:
				tmp_orig2.append(orig_matrix[x][z])
		origs_gr[2].append(np.average(tmp_orig2))
		word_ratio.append(1.*g/tentative)
	creats.append(creats_tmp)

	auth = compos[x]["userid"]
	influ = 0
	if auth in users_gues.keys():
		for y in users_gues[auth]:
			if compos[y[0]]["conceptid"] == compos[x]["conceptid"]:
				if y[1] < creats_tmp:
					influ = 1
	if auth in users_comp.keys():
		for y in users_comp[auth]:
			if compos[y]["conceptid"] == compos[x]["conceptid"]:
				if int(y[2:]) < creats_tmp:
					influ = 1
	if influ == 1:
		orig_influ.append(compos[x]["originality"])
	else:
		orig_ninflu.append(compos[x]["originality"])


#print sorted(compos_topic["1_casa"])

# constants
#dpi = 72; imageSize = (32,32)
# read in our png file

for k in compos_topic.keys():
	if k[0] == "1":
		print k
		li_ori = []
		li_val = []
		fig = plt.gcf()
		fig.clf()
		ax = plt.subplot(111)
		npi = []
		for x in sorted(compos_topic[k]):
			if x not in comp_exl:
				npi.append(len(compos[x]["matrix"]))
		for x in sorted(compos_topic[k]):
			if x not in comp_exl:
				tmp_orig = []
				for z in orig_matrix[x].keys():
#					if z < x and z not in comp_exl:
					if z not in comp_exl:
						if compos[z]["conceptid"] == compos[x]["conceptid"]:
							tmp_orig.append(orig_matrix[x][z])
					if len(tmp_orig) == 0:
						tmp_orig.append(1)
				if "guesses" in compos[x].keys():
					g = len(compos[x]["guesses"])
				else:
					g = 0
				if "notguesses" in compos[x].keys():
					ng = len(compos[x]["notguesses"])
				else:
					ng = 0
				if g +ng > 0:
					indo = 1.0*g/(g+ng)
				else:
					indo = 0
				if "ratings" in compos[x].keys():
					tot = len(compos[x]["ratings"])
					res = 0
					for y in compos[x]["ratings"]:
						res += int(compos[x]["ratings"][y]["vote"])
					if tot > 0:
						rat = res/tot
					else:
						rat = 0
				stars = compos[x]["stars"]/3.
				numpix = (np.average(npi) - len(compos[x]["matrix"]))/np.std(npi)
				val = (indo + numpix + rat)/3.
				ori = np.average(tmp_orig)
				li_ori.append(ori)
				li_val.append(val)
				arr_vic = read_png('filesart/compositions/images/' + x + '_80.png')
				imagebox = OffsetImage(arr_vic, zoom=.15)
				xy = [val, ori]                  
				bbox_props = dict(boxstyle="square,pad=0.001", lw=0)
				ab = AnnotationBbox(imagebox, xy, boxcoords="offset points", bboxprops=bbox_props)
				ax.add_artist(ab)
		ax.grid(True)
		plt.xlim(min(li_val)-.05,max(li_val)+.05)
		plt.ylim(min(li_ori)-.02,max(li_ori)+.02)
		plt.ylabel('Originality (all vs all, no time)')
		plt.xlabel('Value (guess ratio + likes/dislike - numpix)')
#		plt.show()
		savefig("creativity/creativity_"+k+".pdf")
		plt.close()




com_list = [ len(users_comp[x]) for x in users_comp.keys()]
hist(com_list,bins=2*int(math.sqrt(len(com_list))) ,label="Compositions per user")
legend()
savefig("pics/compoPERuser.pdf")
plt.close()

gue_list = [ len(users_gues[x]) for x in users_gues.keys()]
hist(gue_list,bins=2*int(math.sqrt(len(gue_list))),label="Guess per user")
legend()
savefig("pics/guessPERuser.pdf")
plt.close()

topic_temporalclustering = {}
topic_finalclustering = {}
for x in compos_topic.keys(): 
	if len(compos_topic[x]) > 10:
		dist = {}
		alls = []
		sor = sorted(compos_topic[x])
		for i in range(len(sor)):
			for j in range(i+1,len(sor)):
				if j-i not in dist.keys():
					dist[j-i] = []
				dist[j-i].append(orig_matrix[sor[i]][sor[j]])
				alls.append(orig_matrix[sor[i]][sor[j]])
		print x, len(compos_topic[x])

		G=nx.Graph()
		clust = []
		for i in range(1,len(sor)):
			for j in range(0,i):
				if orig_matrix[sor[j]][sor[i]] < np.average(alls) * 1.1:
					G.add_edge(j,i,weight=1-orig_matrix[sor[j]][sor[i]])
			if len(G.edges(data=True)) > 0:
				clust.append(nx.average_clustering(G,weight="weight"))		
			else:
				clust.append(0)
		plot(range(len(clust)),clust,label="threshold = +10%")

		G=nx.Graph()
		clust = []
		for i in range(1,len(sor)):
			for j in range(0,i):
				if orig_matrix[sor[j]][sor[i]] < np.average(alls) *.9:
					G.add_edge(j,i,weight=1-orig_matrix[sor[j]][sor[i]])
			if len(G.edges(data=True)) > 0:
				clust.append(nx.average_clustering(G,weight="weight"))		
			else:
				clust.append(0)
		plot(range(len(clust)),clust,label="threshold = -10%")

		G=nx.Graph()
		clust = []
		for i in range(1,len(sor)):
			for j in range(0,i):
				if orig_matrix[sor[j]][sor[i]] < np.average(alls):
					G.add_edge(j,i,weight=1-orig_matrix[sor[j]][sor[i]])
			if len(G.edges(data=True)) > 0:
				clust.append(nx.average_clustering(G,weight="weight"))		
			else:
				clust.append(0)
		plot(range(len(clust)),clust,label="threshold = <W>")
		topic_finalclustering[x] = nx.average_clustering(G,weight="weight")
		"""
		we = [y[2]["weight"] for y in G.edges(data=True)]
		np.random.shuffle(we)
		cnt = 0
		for y in G.edges():
			G[y[0]][y[1]]["weight"] = we[cnt]
			cnt +=1
		clust = []
		for i in range(1,len(sor)):
			H = G.subgraph(range(i))
	#		print G.nodes(), sor[:i], H.nodes()
			if len(H.edges(data=True)) > 0:
				clust.append(nx.average_clustering(H,weight="weight"))		
			else:
				clust.append(0)
		plot(range(len(clust)),clust,label="threshold = (resh)")
"""
		we = [y[2]["weight"] for y in G.edges(data=True)]
		fillers = [0]*(len(alls)-len(we))
		we.extend(fillers)
		np.random.shuffle(we)
#		print we
		cnt = 0
		G=nx.Graph()
		clust = []
		for i in range(1,len(sor)):
			for j in range(0,i):
				if we[cnt] >0:
					G.add_edge(j,i,weight=we[cnt])
				cnt += 1
			if len(G.edges(data=True)) > 0:
				clust.append(nx.average_clustering(G,weight="weight"))		
			else:
				clust.append(0)
		plot(range(len(clust)),clust,label="rewired")
		G=nx.Graph()
		clust = []
		for i in range(1,len(sor)):
			for j in range(0,i):
				if np.random.rand() < np.average(alls):
					G.add_edge(j,i,weight=np.random.rand())
			if len(G.edges(data=True)) > 0:
				clust.append(nx.average_clustering(G,weight="weight"))		
			else:
				clust.append(0)
		plot(range(len(clust)),clust,label="random")
		plt.title('AVG Clustering for "'+x[2:]+'" vs graph growth')
		grid()
		plt.ylim(0,1)
		legend(ncol=2)
		savefig("pics/AVGClustering_"+x[2:]+".pdf")
		plt.close()

#		print "all avg std", np.average(alls), np.std(alls), len(alls)
#		print "first avg std", np.average(dist[1]), np.std(dist[1])
#		print "second avg std", np.average(dist[2]), np.std(dist[2])
#		print "third avg std", np.average(dist[3]), np.std(dist[3])

		compar1 = (np.average(dist[1]) - np.average(alls))/(math.sqrt( np.var(dist[1])/len(dist[1]) + np.var(alls)/len(alls)) )
		compar2 = (np.average(dist[2]) - np.average(alls))/(math.sqrt( np.var(dist[2])/len(dist[2]) + np.var(alls)/len(alls)) )
		compar3 = (np.average(dist[3]) - np.average(alls))/(math.sqrt( np.var(dist[3])/len(dist[3]) + np.var(alls)/len(alls)) )
		topic_temporalclustering[x] = [compar1,compar2,compar3]

colors = ['r','g','b']
style = ['o','^','s','+','x']
c_cnt = 0
s_cnt = 0
grid()
plt.title('Average Rescaled Dissimilarity vs Temporal Distance')
for x in topic_temporalclustering.keys():
	scatter([1,2,3],topic_temporalclustering[x],label=x[2:],c=colors[c_cnt%len(colors)],marker=style[s_cnt%len(style)],alpha=.7,s=5*len(compos_topic[x]))
	c_cnt +=1
	s_cnt +=1

plot([.5,3.5],[0,0])
plt.xlim(.5,3.5)
plt.ylim(-3,3)
legend(ncol=3, loc=8)
savefig("pics/TemporalClustering.pdf")
plt.close()

"""		avg_thresh = {}
		for y in dist.keys():
			thresh = []
			for z in dist[y]:
				if z > np.average(alls):
					thresh.append(0)
				else:
					thresh.append(1)
			avg_thresh[y] = np.average(thresh),np.std(thresh)
		errorbar(avg_thresh.keys(),[k[0] for k in avg_thresh.values()],yerr=[k[1]/math.sqrt(len(thresh)) for k in avg_thresh.values()], label="Under Thresh Ratio " + x[2:])

		dist = {}
		alls = []
		sor = sorted(compos_topic[x])
		np.random.shuffle(sor)
		for i in range(len(sor)):
			for j in range(i+1,len(sor)):
				if j-i not in dist.keys():
					dist[j-i] = []
				dist[j-i].append(orig_matrix[sor[i]][sor[j]])
				alls.append(orig_matrix[sor[i]][sor[j]])
		print x, len(compos_topic[x])

#		print "all avg std", np.average(alls), np.std(alls)
#		print "first avg std", np.average(dist[1]), np.std(dist[1])
#		print "second avg std", np.average(dist[2]), np.std(dist[2])
#		compar = (np.average(dist[1]) - np.average(dist[2]))/(math.sqrt( np.var(dist[1])/len(dist[1]) + np.var(dist[2])/len(dist[2])) )
#		print "comparison", compar

		avg_thresh = {}
		for y in dist.keys():
			thresh = []
			for z in dist[y]:
				if z > np.average(alls):
					thresh.append(0)
				else:
					thresh.append(1)
			avg_thresh[y] = np.average(thresh),np.std(thresh)
		errorbar(avg_thresh.keys(),[k[0] for k in avg_thresh.values()],yerr=[k[1]/math.sqrt(len(thresh)) for k in avg_thresh.values()], label="Resh Under Thresh Ratio " + x[2:])
		grid()
		legend()
		show()
"""
#		errorbar(dist.keys(), [np.average(dist[i]) for i in dist.keys()] ,yerr=[np.std(dist[i])/math.sqrt(len(dist[i])) for i in dist.keys()], label="Diss Ave")

#		diss_ave = np.average(alls)
#		plot([0,len(dist.keys())], [diss_ave,diss_ave], label="AVG"+x )


#		dist_l = []
#		diss_l = []

#		for x in dist.keys():
#			for y in dist[x]:
#				diss_l.append(y)
#				dist_l.append(x)

#		print "r = ", scipy.stats.pearsonr(dist_l,diss_l)
#		np.random.shuffle(diss_l)
#		print "r = ", scipy.stats.pearsonr(dist_l,diss_l), "resh"
print len(creats), "Compositions"
print len(guessts), "Guess"
print len(users_comp.keys()), "Users"
plt.xlim(1441929600,1445472000)
bbins = arange(1441065600,1446336000,86400)[10:-10]
bblab = [datetime.datetime.fromtimestamp(int(x)-1).strftime('%Y-%m-%d') for x in bbins]
hist(creats,bins=[x - 43200 for x in bbins],label="Compositions per day")
plt.xticks(bbins, bblab, rotation='vertical',fontsize = 5)
legend(loc=2)
savefig("pics/compositionPERday.pdf")
plt.close()

plt.xlim(1441929600,1445472000)
bbins = arange(1441065600,1446336000,86400)[10:-10]
bblab = [datetime.datetime.fromtimestamp(int(x)-1).strftime('%Y-%m-%d') for x in bbins]
hist(guessts,bins=[x - 43200 for x in bbins],label="Guess per day")
plt.xticks(bbins, bblab, rotation='vertical',fontsize = 5)
legend(loc=2)
savefig("pics/guessPERday.pdf")
plt.close()

hist(numpix,bins=20,label="Num Pixel")
legend()
savefig("pics/NumPixel.pdf")
plt.close()

hist(intert,bins=20,label="Duration")
legend()
savefig("pics/Duration.pdf")
plt.close()

hist(interlen,bins=20,label="Num Interactions")
legend()
savefig("pics/Interactions.pdf")
plt.close()

hist(games,bins=20,label="Games on each composition")
legend()
savefig("pics/GamesPERcomposition.pdf")
plt.close()

#hist(words,bins=20)
#legend()
#savefig("pics/.pdf")
#plt.close()

hist(guesses,bins=20,label="Guesses on each composition")
legend()
savefig("pics/GuessPERcomposition.pdf")
plt.close()


hist([guesses[i]/games[i] for i in range(len(games)) if games[i] > 0],bins=20,label="Guesses per Game")
legend()
savefig("pics/GuessPERgame.pdf")
plt.close()


hist(guess_ratio,bins=20,label="Guess Ratio")
legend(loc=2)
savefig("pics/GuesRatio.pdf")
plt.close()


hist(word_ratio,bins=20,label="Word Ratio")
legend()
savefig("pics/WordRatio.pdf")
plt.close()

scatter(origs_gr[0], word_ratio,label="Originality (old) vs word ratio (r="+str(scipy.stats.pearsonr(origs_gr[0], word_ratio)[0])[:5]+")")
legend()
savefig("pics/origVSword_ratio.pdf")
plt.close()

scatter(origs_gr[0], origs_gr[1],label="Originality (old) vs guess ratio (r="+str(scipy.stats.pearsonr(origs_gr[0], origs_gr[1])[0])[:5]+")")
legend()
savefig("pics/origVSguess_ratio.pdf")
plt.close()

scatter(origs_gr[0], origs_gr[2],label="Originality (old) vs Originality (new) (r="+str(scipy.stats.pearsonr(origs_gr[0], origs_gr[2])[0])[:5]+")")
legend()
savefig("pics/origVSorig.pdf")
plt.close()

scatter(origs_gr[2], word_ratio,label="Originality (new) vs word ratio (r="+str(scipy.stats.pearsonr(word_ratio, origs_gr[2])[0])[:5]+")")
legend()
savefig("pics/orig_nVSword_ratio.pdf")
plt.close()

scatter(origs_gr[2], origs_gr[1],label="Originality (new) vs guess ratio (r="+str(scipy.stats.pearsonr(origs_gr[1], origs_gr[2])[0])[:5]+")")
legend()
savefig("pics/orig_nVSguess_ratio.pdf")
plt.close()



hist(origs,bins=20,label="Originality (old)")
legend()
savefig("pics/orig.pdf")
plt.close()

scatter(origs_interlen[0], origs_interlen[1],label="Originality vs Num Interaction")
#print scipy.stats.pearsonr(origs_interlen[0], origs_interlen[1])
legend()
savefig("pics/OrigVSnumInter.pdf")
plt.close()

scatter(origs_intert[0], origs_intert[1],label="Originality vs Duration")
#print scipy.stats.pearsonr(origs_intert[0], origs_intert[1])
legend()
savefig("pics/OrigVSduration.pdf")
plt.close()


#print len(orig_influ), len(orig_ninflu)
hist(orig_influ,bins=15,alpha=0.5,label="Inf", normed=1)
hist(orig_ninflu,bins=15,alpha=0.5,label="Ninf", normed=1)
legend()
savefig("pics/Inf_Ninf.pdf")
plt.close()


wordcloud = WordCloud(width=800,height=600).generate(" ".join(words))
plt.imshow(wordcloud)
plt.axis('off')
savefig("pics/GlobalWordCloud.pdf", dpi=300,bbox_inches=None, pad_inches=None)
plt.close()

"""font = {'family' : 'normal',
        'weight' : 'bold',
        'size'   : 8}

matplotlib.rc('font', **font)
"""
entro = {}
for x in topic_words:
	if x[0]== "1":
		print x
		wordcloud = WordCloud(width=800,height=600).generate(" ".join(topic_words[x]))
		plt.imshow(wordcloud)
		plt.axis('off')
		savefig("pics/"+x[2:]+"_WordCloud.pdf", dpi=300,bbox_inches=None, pad_inches=None)
		plt.close()
		plt.ylim(0.8,1000)
		labels, values = zip(*Counter(topic_words[x]).items())
		indexes = np.arange(len(labels))
		width = 1
		plt.bar(indexes,[v for (v,l) in reversed(sorted(zip(values,labels)))], width,log=True)
		plt.xticks(indexes + width * 0.5, [l[:min(10,len(l))] for (v,l) in reversed(sorted(zip(values,labels)))], rotation='vertical',fontsize = 7)
#		print "Entropy = " + str(scipy.stats.entropy(values)) + ", "+ str(scipy.stats.entropy(values)/ math.log(len(values)))
		savefig("pics/"+x[2:]+"_wordFR.pdf",bbox_inches="tight")
		plt.close()
		entro[x] = scipy.stats.entropy(values)/ math.log(len(values))


"""for x in orig_t:
	if x[0] == "1":
		baseline = np.average([np.average(orig_matrix[y].values()) for y in compos_topic[x]])
		run_ave = np.convolve([y for y in orig_t[x]], np.ones((1,))/1, mode='valid')
		plt.plot(range(len(run_ave)),run_ave,label=x)
		plt.plot([1,len(run_ave)],[baseline,baseline],label="")
		run_ave = np.convolve([y for y in new_orig_t[x]], np.ones((1,))/1, mode='valid')
		plt.plot(range(len(run_ave)),run_ave,label=x+" new")
		plt.legend()
		plt.show()
"""
baseline={}
for x in new_orig_t:
	if x[0] == "1":
		run_ave = np.convolve([y for y in new_orig_t[x]], np.ones((5,))/5, mode='valid')
		baseline[x] = np.average(run_ave[:])
		plt.plot(range(len(run_ave)),run_ave,label=x[2:])
#		plt.plot([1,len(run_ave)],[baseline[x],baseline[x]])
plt.legend(ncol=2)
savefig("pics/Orig(new)VSn.pdf",bbox_inches="tight")
plt.close()
for x in new_orig_t:
	if x[0] == "1":
		run_ave = np.convolve([y-baseline[x] for y in new_orig_t[x]], np.ones((5,))/5, mode='valid')
		plt.plot(range(len(run_ave)),run_ave,label=x[2:])
plt.legend(ncol=2)
savefig("pics/Orig(new_rescaledAVG)VSn.pdf",bbox_inches="tight")
plt.close()

sorted_entro = sorted(entro, key=entro.get,reverse=True)
plt.bar(range(len(entro.keys())),[entro[x] for x in sorted_entro], .8)
plt.xticks([x +.4 for x in range(len(entro.keys()))], sorted_entro, rotation='vertical',fontsize = 10)
savefig("pics/EntroVStopics.pdf",bbox_inches="tight")
plt.close()

plt.scatter([topic_guess_ratio[x][0]/topic_guess_ratio[x][1] for x in entro.keys()],[entro[x] for x in entro.keys()],label="Entropy vs Topic Guess Ratio (r="+str(scipy.stats.pearsonr([topic_guess_ratio[x][0]/topic_guess_ratio[x][1] for x in entro.keys()],[entro[x] for x in entro.keys()])[0])[:5]+")")
plt.legend()
savefig("pics/EntroVSdiff_topicagg.pdf",bbox_inches="tight")
plt.close()

topic_guess_ratio

sorted_bricks = sorted(bricks, key=bricks.get,reverse=True)
plt.loglog(range(len(bricks.keys())),[bricks[x] for x in sorted_bricks])
#plt.xticks([x +.4 for x in range(len(bricks.keys()))], sorted_bricks, rotation='vertical',fontsize = 10)
savefig("pics/Bricks.pdf",bbox_inches="tight")
plt.close()

for x in topic_bricks.keys():
	if x[0] == "1":
		sorted_bricks = sorted(topic_bricks[x], key=topic_bricks[x].get,reverse=True)
		plt.loglog(range(len(sorted_bricks)),[topic_bricks[x][y] for y in sorted_bricks], label=x[2:])

plt.legend(ncol=2)
savefig("pics/TopicBricks.pdf",bbox_inches="tight")
plt.close()


